%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Coord_Delete(Coord_list)

global ErrCode;

global DB_COORD;
global AST_COORD;
global AT_COORD;

Coord_list = unique(Coord_list);

% Проверка существования в базе систем координат
for i=1:size(Coord_list,1)
    if (~DB_Coord_Exist(Coord_list(i)))
        fprintf (1, '\nОшибка функции DB_Coord_Delete: система координат с номером %i отсутствует в базе !\n', Coord_list(i));
        ErrCode = -1;
        return;
    end
end

% Проверка задействованности систем координат
for i=1:size(Coord_list,1)
    
    Node_list = AST_COORD{AT_COORD(Coord_list(i))}.Node_list;
    PSet_list = AST_COORD{AT_COORD(Coord_list(i))}.PSet_list;
    
    if (~isempty(Node_list))
        if (size(Node_list,1) == 1)
            node_word = 'узле';
        else
            node_word = 'узлах';
        end
        fprintf (1, '\nОшибка функции DB_Coord_Delete: система координат с номером %i используется в %s:\n', Coord_list(i), node_word);
        column_print_counter = 0;
        row_print_counter = 0;
        for j=1:size(Node_list,1)
            fprintf (1, ' %i', Node_list(j));
            column_print_counter = column_print_counter + 1;
            if (column_print_counter == 10)
                column_print_counter = 0;
                row_print_counter = row_print_counter + 1;
                fprintf (1, '\n');
            end
            if (row_print_counter == 10)
                break;
            end
        end
        if (j < size(Node_list,1))
            fprintf (1, '(показано %i узлов из %i)\n', j, size(Node_list,1));
        else
            fprintf (1, '\n');
        end
        ErrCode = -1;
        return;
    end
    
    if (~isempty(PSet_list))
        fprintf (1, '\nОшибка функции DB_Coord_Delete: система координат с номером %i используется в property set:\n', Coord_list(i));
        column_print_counter = 0;
        row_print_counter = 0;
        for j=1:size(PSet_list,1)
            fprintf (1, ' %i', PSet_list(j));
            column_print_counter = column_print_counter + 1;
            if (column_print_counter == 10)
                column_print_counter = 0;
                row_print_counter = row_print_counter + 1;
                fprintf (1, '\n');
            end
            if (row_print_counter == 10)
                break;
            end
        end
        if (j < size(PSet_list,1))
            fprintf (1, '(показано %i property set из %i)\n', j, size(PSet_list,1));
        else
            fprintf (1, '\n');
        end
        ErrCode = -1;
        return;
    end
    
end

% Удаление систем координат из базы данных и адресной таблицы
for i=1:size(Coord_list,1)
    
    DB_COORD{AT_COORD(Coord_list(i))}.ID = -1;
    AT_COORD(Coord_list(i)) = 0;

end
